diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
index 0ae26536f..e39c3cbff 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
@@ -4,6 +4,7 @@ package net.minecraft.core.block.entity;
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ListTag;
+import net.minecraft.core.block.BlockLogicRotatable;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.BlockLogicChest;
 import net.minecraft.core.block.BlockLogicTrommel;
@@ -21,6 +22,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
@@ -35,6 +37,7 @@ import java.util.Random;
 public class TileEntityTrommel extends TileEntity
         implements Container
 {
+    public static final int FUEL_SLOT_INDEX = 4;
 
     public TileEntityTrommel()
     {
@@ -118,7 +121,7 @@ public class TileEntityTrommel extends TileEntity
 
         burnTime = compoundTag.getShort("BurnTime");
         itemPopTime = compoundTag.getShort("CookTime");
-        currentItemBurnTime = getItemBurnTime(itemStacks[1]);
+        currentItemBurnTime = getItemBurnTime(itemStacks[FUEL_SLOT_INDEX]);
     }
 
     @Override
@@ -181,10 +184,10 @@ public class TileEntityTrommel extends TileEntity
         if(!isClient)
         {
         	if(worldObj == null || worldObj.getBlockId(x, y, z) == Blocks.TROMMEL_IDLE.id()) {
-            	if(currentItemBurnTime == 0 && itemStacks[0] == null) {
-            		if(itemStacks[4] != null && itemStacks[4].itemID == Blocks.COBBLE_NETHERRACK.id()) {
-            			itemStacks[4].stackSize--;
-            			if(itemStacks[4].stackSize <= 0) itemStacks[4] = null;
+            	if(currentItemBurnTime == 0 && itemStacks[0] == null && itemStacks[1] == null && itemStacks[2] == null && itemStacks[3] == null) {
+            		if(itemStacks[FUEL_SLOT_INDEX] != null && itemStacks[FUEL_SLOT_INDEX].itemID == Blocks.COBBLE_NETHERRACK.id()) {
+            			itemStacks[FUEL_SLOT_INDEX].stackSize--;
+            			if(itemStacks[FUEL_SLOT_INDEX].stackSize <= 0) itemStacks[FUEL_SLOT_INDEX] = null;
             			if (worldObj != null) {
                             BlockLogicTrommel.updateTrommelBlockState(true, worldObj, x, y, z);
                         } else if (carriedBlock != null) {
@@ -198,19 +201,19 @@ public class TileEntityTrommel extends TileEntity
                 nextToSieve = (nextToSieve+1)%4;
             if(burnTime == 0 && canProduce(nextToSieve))
             {
-                currentItemBurnTime = burnTime = getItemBurnTime(itemStacks[4]);
+                currentItemBurnTime = burnTime = getItemBurnTime(itemStacks[FUEL_SLOT_INDEX]);
                 if(burnTime > 0)
                 {
                     flag1 = true;
-                    if(itemStacks[4] != null)
+                    if(itemStacks[FUEL_SLOT_INDEX] != null)
                     {
-                    	if(itemStacks[4].getItem() == Items.BUCKET_LAVA) {
-                    		itemStacks[4] = new ItemStack(Items.BUCKET);
+                    	if(itemStacks[FUEL_SLOT_INDEX].getItem() == Items.BUCKET_LAVA) {
+                    		itemStacks[FUEL_SLOT_INDEX] = new ItemStack(Items.BUCKET);
                     	}else {
-                            itemStacks[4].stackSize--;
-                            if(itemStacks[4].stackSize <= 0)
+                            itemStacks[FUEL_SLOT_INDEX].stackSize--;
+                            if(itemStacks[FUEL_SLOT_INDEX].stackSize <= 0)
                             {
-                                itemStacks[4] = null;
+                                itemStacks[FUEL_SLOT_INDEX] = null;
                             }
                     	}
                     }
@@ -267,62 +270,59 @@ public class TileEntityTrommel extends TileEntity
         if(itemResult!=null)
         {
         	// Check if chest is adjacent
-        	int xOffset = 0;
-        	int zOffset = 0;
+            Direction direction = Direction.NONE;
         	if (worldObj != null) {
-                int meta = worldObj.getBlockMetadata(x, y, z) & 0x07;
-                if (meta == 2)
-                {
-                    xOffset = -1;
-                }
-                else if (meta == 5)
-                {
-                    zOffset = -1;
-                }
-                else if (meta == 3)
-                {
-                    xOffset = 1;
-                }
-                else if (meta == 4)
-                {
-                    zOffset = 1;
+                // 90-degree rotation CCW around the y-axis to get the direction of the output slot
+                switch (BlockLogicRotatable.getDirectionFromMeta(worldObj.getBlockMetadata(x, y, z))) {
+                    case NORTH: {
+                        direction = Direction.WEST;
+                        break;
+                    }
+                    case SOUTH: {
+                        direction = Direction.EAST;
+                        break;
+                    }
+                    case WEST: {
+                        direction = Direction.SOUTH;
+                        break;
+                    }
+                    case EAST: {
+                        direction = Direction.NORTH;
+                        break;
+                    }
                 }
             }
-        	int adjacentId = worldObj != null ? worldObj.getBlockId(x + xOffset, y, z + zOffset) : 0;
-        	
-        	Container chest = null;
-        	if (Block.hasLogicClass(Blocks.blocksList[adjacentId], BlockLogicChest.class)) {
-                assert worldObj != null;
-                chest = BlockLogicChest.getInventory(worldObj, x + xOffset, y, z + zOffset);
-        	}
-        	
-        	if (chest != null)
-        	{
-        		for (int i = 0; i < chest.getContainerSize(); i++)
-        		{
-        			ItemStack slot = chest.getItem(i);
-        			if (slot != null && slot.itemID == itemResult.itemID && slot.getMetadata() == itemResult.getMetadata())
-        			{
+        	int adjacentId = worldObj != null ? worldObj.getBlockId(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ()) : 0;
+
+        	if (worldObj != null && Block.hasLogicClass(Blocks.blocksList[adjacentId], BlockLogicChest.class)) {
+                Container chest = BlockLogicChest.getInventory(worldObj, x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ());
+
+                for (int i = 0; i < chest.getContainerSize(); i++)
+                {
+                    ItemStack slot = chest.getItem(i);
+                    if (slot != null && slot.itemID == itemResult.itemID && slot.getMetadata() == itemResult.getMetadata())
+                    {
                         for(; slot.stackSize + 1 <= slot.getMaxStackSize(); itemResult.stackSize--){
                             slot.stackSize ++;
                             chest.setItem(i, slot);
                             if(itemResult.stackSize <= 0)
                                 return;
                         }
-        			}
-        		}
+                    }
+                }
                 if(itemResult.stackSize <= 0)
                     return;
-        		for (int i = 0; i < chest.getContainerSize(); i++)
-        		{
-        			ItemStack slot = chest.getItem(i);
-        			if (slot == null)
-        			{
-        				chest.setItem(i, itemResult);
-        				return;
-        			}
-        		}
+                for (int i = 0; i < chest.getContainerSize(); i++)
+                {
+                    ItemStack slot = chest.getItem(i);
+                    if (slot == null)
+                    {
+                        chest.setItem(i, itemResult);
+                        return;
+                    }
+                }
         	}
+
             if(itemResult.stackSize > 0) {
                 if (worldObj != null) {
                     worldObj.dropItem(x, y, z, itemResult);
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingWithTool.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingWithTool.java
index c8f46f4b9..1f78ec708 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingWithTool.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingWithTool.java
@@ -36,9 +36,9 @@ public class RecipeEntryCraftingWithTool extends RecipeEntryCraftingDynamic impl
             for (int y = 0; y < 3; y++) {
                 ItemStack stack = containerCrafting.getItemStackAt(x, y);
                 if (stack == null) continue;
-                if (toolToUse.matches(stack)) {
+                if (toolToUse.matches(stack) && !toolMatch) {
                     toolMatch = true;
-                } else if (inputSymbol.matches(stack)) {
+                } else if (inputSymbol.matches(stack) && !itemMatch) {
                     itemMatch = true;
                 } else {
                     return false;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index ae747c612..659f3516a 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -1241,7 +1241,7 @@ public abstract class Entity
         if (vehicle == null) {
             return;
         }
-        if(vehicle.isRemoved() || isSneaking())
+        if(vehicle.isRemoved() || isSneaking() || (vehicle instanceof Entity && !((Entity) vehicle).isAlive()))
         {
             vehicle.ejectRider();
             return;
@@ -1317,6 +1317,10 @@ public abstract class Entity
         }
         this.vehicle = vehicle;
         vehicle.setPassenger(this);
+        if (vehicle instanceof Entity) {
+            ((Entity) vehicle).fallDistance += this.fallDistance;
+            this.fallDistance = 0;
+        }
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index 2d5bf8b3e..c4de84b39 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -715,7 +715,9 @@ public abstract class Mob extends Entity
         int i = (int) java.lang.Math.ceil(distance - 3F);
         if(i > 0)
         {
-            hurt(null, i, DamageType.FALL);
+            if (vehicle == null) {
+                hurt(null, i, DamageType.FALL);
+            }
             int j = world.getBlockId(MathHelper.floor(x), MathHelper.floor(y - 0.2D - (double) heightOffset), MathHelper.floor(z));
             if(j > 0)
             {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
index a4d546a7a..93292301d 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
@@ -104,6 +104,11 @@ public class MobPig
         }
     }
 
+    @Override
+    protected boolean canDespawn() {
+        return super.canDespawn() && !getSaddled();
+    }
+
     @Override
 	protected void dropDeathItems()
     {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index 1ee88b1c0..2a0280a1b 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -80,6 +80,7 @@ public abstract class Player
     public static final int DATA_HELD_ARROW = 18;
     public static final TextFormatting deathMsgColor = TextFormatting.RED;
     public ContainerInventory inventory;
+    public final @Nullable ItemStack @NotNull [] oldArmorInventory = new ItemStack[4]; // Last tick's armor inventory, used for playing equip sounds at the right time.
     public MenuAbstract inventorySlots;
     public MenuAbstract craftingInventory;
     public Gamemode gamemode = Gamemode.survival;
@@ -261,6 +262,19 @@ public abstract class Player
         ydO = yd;
         zdO = zd;
 
+        boolean playEquipSound = false;
+        for (int i = 0; i < oldArmorInventory.length; i++) {
+            ItemStack armorOld = oldArmorInventory[i];
+            ItemStack armorCurrent = inventory.armorInventory[i];
+            if (armorOld != armorCurrent && (armorOld == null || armorCurrent == null || armorOld.itemID != armorCurrent.itemID)) {
+                playEquipSound = true;
+            }
+            oldArmorInventory[i] = armorCurrent;
+        }
+        if (playEquipSound) {
+            world.playSoundAtEntity(this, this, "random.equip", 2f, 1f);
+        }
+
         final boolean wSneak = wantSneak();
 
         if (wSneak || this.noPhysics) {
@@ -804,6 +818,11 @@ public abstract class Player
         nickname = nickname.replace(" ", "");
         ListTag nbttaglist = tag.getList("Inventory");
         inventory.readFromNBT(nbttaglist);
+
+        for (int i = 0; i < oldArmorInventory.length; i++) {
+            oldArmorInventory[i] = inventory.armorInventory[i];
+        }
+
         inventory.setCurrentItemIndex(tag.getIntegerOrDefault("CurrentItem", inventory.getCurrentItemIndex()), true);
         inventory.setHotbarOffset(tag.getIntegerOrDefault("HotbarOffset", inventory.getHotbarOffset()), true);
         int dim = tag.getInteger("Dimension");
diff --git a/game/core/src/main/java/net/minecraft/core/item/Item.java b/game/core/src/main/java/net/minecraft/core/item/Item.java
index 09b73dc9a..695cd14de 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Item.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Item.java
@@ -172,7 +172,7 @@ public class Item implements ITaggable<Item>, IItemConvertible
         return 1.0F;
     }
 
-    public ItemStack onUseItem(final ItemStack itemstack, final World world, final Player entityplayer)
+    public @Nullable ItemStack onUseItem(final @NotNull ItemStack itemstack, final @NotNull World world, final @NotNull Player entityplayer)
     {
         return itemstack;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemArmor.java b/game/core/src/main/java/net/minecraft/core/item/ItemArmor.java
index fca353a28..ce2682ecf 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemArmor.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemArmor.java
@@ -1,8 +1,12 @@
 package net.minecraft.core.item;
 
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.enums.IArmorShape;
 import net.minecraft.core.item.material.ArmorMaterial;
+import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ItemArmor<T extends IArmorShape>
 	extends Item
@@ -20,6 +24,17 @@ public class ItemArmor<T extends IArmorShape>
 		this.maxStackSize = 1;
 	}
 
+	@Override
+	public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer) {
+        if (!(armorShape instanceof HumanArmorShape)) {
+			return itemstack;
+        }
+		HumanArmorShape humanArmorShape = (HumanArmorShape) armorShape;
+		ItemStack currentArmorInSlot = entityplayer.getItemInArmorSlot(humanArmorShape);
+		entityplayer.setItemInArmorSlot(humanArmorShape, itemstack);
+		return currentArmorInSlot;
+	}
+
 	@Override
 	public ArmorMaterial getArmorMaterial() {
 		return this.material;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java b/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java
index 76896042d..96621c3d9 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java
@@ -9,6 +9,8 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -22,7 +24,7 @@ public class ItemBoat extends Item
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+    public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer)
     {
         float f = 1.0F;
         float f1 = entityplayer.xRotO + (entityplayer.xRot - entityplayer.xRotO) * f;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBow.java b/game/core/src/main/java/net/minecraft/core/item/ItemBow.java
index 753c3c630..f5b0dd600 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBow.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBow.java
@@ -7,6 +7,8 @@ import net.minecraft.core.entity.projectile.ProjectileArrowPurple;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ItemBow extends Item
 {
@@ -19,7 +21,7 @@ public class ItemBow extends Item
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+    public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer)
     {
         ItemStack quiverSlot = entityplayer.getItemInArmorSlot(HumanArmorShape.CHEST);
         if(quiverSlot != null && quiverSlot.itemID == Items.ARMOR_QUIVER.id && quiverSlot.getMetadata() < quiverSlot.getMaxDamage()){
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
index 0214ee54f..e1725df22 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
@@ -11,6 +11,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
@@ -26,7 +27,7 @@ public class ItemBucket extends Item
     }
 
     @Override
-	public ItemStack onUseItem(ItemStack stack, World world, Player player) {
+	public @Nullable ItemStack onUseItem(@NotNull ItemStack stack, @NotNull World world, @NotNull Player player) {
 		if(blockToPlace == null) {
 			// Milk
 			return new ItemStack(Items.BUCKET);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
index 73fa99245..e31ac5755 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
@@ -8,6 +8,8 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.List;
 import java.util.Random;
@@ -22,7 +24,7 @@ public class ItemBucketEmpty extends Item
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+    public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer)
     {
         double reachDistance = entityplayer.getGamemode().getBlockReachDistance();
         HitResult hitResult = entityplayer.rayTrace(reachDistance, 1f, true, false, false);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucketIceCream.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucketIceCream.java
index c4bfbf4a7..1e0627fcf 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucketIceCream.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucketIceCream.java
@@ -2,6 +2,8 @@ package net.minecraft.core.item;
 
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ItemBucketIceCream extends ItemFood {
 
@@ -11,7 +13,7 @@ public class ItemBucketIceCream extends ItemFood {
         maxStackSize = 1;
     }
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+    public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer)
     {
         if (entityplayer.getHealth() < entityplayer.getMaxHealth()){
             super.onUseItem(itemstack, world, entityplayer);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemEgg.java b/game/core/src/main/java/net/minecraft/core/item/ItemEgg.java
index 93de7e207..878b8b6c2 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemEgg.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemEgg.java
@@ -5,6 +5,8 @@ import net.minecraft.core.entity.projectile.ProjectileEgg;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -19,7 +21,7 @@ public class ItemEgg
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+    public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer)
     {
         itemstack.consumeItem(entityplayer);
         world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.5F, 0.4F / (itemRand.nextFloat() * 0.4F + 0.8F));
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemFishingRod.java b/game/core/src/main/java/net/minecraft/core/item/ItemFishingRod.java
index edf198122..614993d29 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemFishingRod.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemFishingRod.java
@@ -3,6 +3,8 @@ package net.minecraft.core.item;
 import net.minecraft.core.entity.EntityFishingBobber;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ItemFishingRod extends Item
 {
@@ -15,7 +17,7 @@ public class ItemFishingRod extends Item
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+    public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer)
     {
         if(entityplayer.bobberEntity != null)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemFood.java b/game/core/src/main/java/net/minecraft/core/item/ItemFood.java
index 7c655c4d7..2cbb2ab18 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemFood.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemFood.java
@@ -2,6 +2,8 @@ package net.minecraft.core.item;
 
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ItemFood extends Item
 {
@@ -20,7 +22,7 @@ public class ItemFood extends Item
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+    public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer)
     {
         if(entityplayer.getHealth() < entityplayer.getMaxHealth()
                 && entityplayer.getHealth() + entityplayer.getTotalHealingRemaining() < entityplayer.getMaxHealth()
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemHandCannonLoaded.java b/game/core/src/main/java/net/minecraft/core/item/ItemHandCannonLoaded.java
index 9b436007b..03e4405c8 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemHandCannonLoaded.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemHandCannonLoaded.java
@@ -3,6 +3,8 @@ package net.minecraft.core.item;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.ProjectileCannonball;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ItemHandCannonLoaded extends Item
 {
@@ -15,7 +17,7 @@ public class ItemHandCannonLoaded extends Item
     }
 
 	@Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+    public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer)
     {
 		world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.3F, 1.0F / (itemRand.nextFloat() * -0.2F - 0.4F));
 
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemHandCannonUnloaded.java b/game/core/src/main/java/net/minecraft/core/item/ItemHandCannonUnloaded.java
index 8c6201eee..64c7464f3 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemHandCannonUnloaded.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemHandCannonUnloaded.java
@@ -2,6 +2,8 @@ package net.minecraft.core.item;
 
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ItemHandCannonUnloaded extends Item
 {
@@ -14,7 +16,7 @@ public class ItemHandCannonUnloaded extends Item
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+    public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer)
     {
         if (entityplayer.inventory.consumeInventoryItem(Items.AMMO_CHARGE_EXPLOSIVE.id))
         {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemIceSkates.java b/game/core/src/main/java/net/minecraft/core/item/ItemIceSkates.java
index 7399d2bd2..da2847fc9 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemIceSkates.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemIceSkates.java
@@ -1,8 +1,10 @@
 package net.minecraft.core.item;
 
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.enums.IArmorShape;
 import net.minecraft.core.item.material.ArmorMaterial;
+import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -12,6 +14,14 @@ public class ItemIceSkates extends Item implements IArmorItem<HumanArmorShape> {
         setMaxStackSize(1);
     }
 
+    @Override
+    public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer) {
+        HumanArmorShape humanArmorShape = getArmorShape();
+        ItemStack currentArmorInSlot = entityplayer.getItemInArmorSlot(humanArmorShape);
+        entityplayer.setItemInArmorSlot(humanArmorShape, itemstack);
+        return currentArmorInSlot;
+    }
+
     @Override
     public @Nullable ArmorMaterial getArmorMaterial() {
         return null;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemJar.java b/game/core/src/main/java/net/minecraft/core/item/ItemJar.java
index 8ab94936b..47204fcc3 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemJar.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemJar.java
@@ -37,7 +37,7 @@ public class ItemJar extends ItemPlaceable {
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, @NotNull Player entityplayer)
+    public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer)
     {
         if (entityplayer.isSneaking()) {
             return itemstack;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java b/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java
index 2150ca357..937f09563 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java
@@ -8,6 +8,8 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.List;
 import java.util.Random;
@@ -20,7 +22,7 @@ public class ItemLabel extends Item
     }
 
 	@Override
-	public ItemStack onUseItem(final ItemStack stack, final World world, final Player player) {
+	public @Nullable ItemStack onUseItem(final @NotNull ItemStack stack, final @NotNull World world, final @NotNull Player player) {
 		if(stack.hasCustomName()) {
 			return stack;
 		}
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemMap.java b/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
index 0a31d74d1..45f9b5fa1 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
@@ -21,9 +21,6 @@ import net.minecraft.core.world.saveddata.maps.ItemMapSavedData;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-import java.util.HashMap;
-import java.util.Map;
-
 
 public class ItemMap extends Item implements IComplexItem
 {
@@ -114,7 +111,7 @@ public class ItemMap extends Item implements IComplexItem
         return mapData;
     }
 	@Override
-	public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+	public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer)
 	{
 		if (!hasInitialized(itemstack)){
 			initMap(itemstack, world, entityplayer);
